class Symbol {
  boolean flag = true;
  boolean flag2 = true;;
  float _globalTime;
  int[] c1;
  int[] c2;
  float _inv1=0;
  float _inv2=0;
  Symbol() {
    c1 = new int[255];
    c2 = new int[255];
    for(int i=0; i<c1.length; i++){
      c1[i] = i;
      c2[i] = 2;
    }
  }
  int   curTime = 0;
  int  animSpeed = 20;
  float time;
  float _angle;
  //parameter: [switch type, diameter, all-rotation, inner-circles scale, inner-circles rotation]
  void drawPermutationObj(int type, float d, float angle, float growY, int anzahl, float[] wiiParam, float animTime, float globalTime)
  {
    _angle = angle;
    type = type%7;
    float r = d/2;  //radius of container circle
    float inv1 = wiiParam[2];
    float inv2 = map(wiiParam[2],0,255,255,0);
    _inv1=inv1;
    _inv2=inv2;
    if(wiiParam[0]==0) {   //wiimote B not pressed
      time = 1.0;
      curTime = 0;
    }
    if(wiiParam[0]==1) {  //wiimote B pressed
      curTime += animSpeed;
      time = curTime * 1.0 / animTime;
      if(curTime >= animTime)
        curTime = 0;
    }
    if(wiiParam[5]==1 && flag) {  //wiimote up pressed
      flag=false;
      animSpeed+=1;
      //println("speed: "+animSpeed);
    }
    else if((wiiParam[5]==0 & wiiParam[6]==0) && !flag)  //wiimote up or down not pressed
      flag=true;

    if(wiiParam[6]==1 && flag) {  //wiimote down pressed
      flag=false;
      animSpeed-=1;
      //println("speed: "+animSpeed);
    }

    pushStyle();

    fill(getColor1(globalTime), inv1,inv1);
    ellipse(((r-3*d/7) * cos(angle-PI/2)), ((r-3*d/7) * sin(angle-PI/2)), time*7*(8*d/7)/anzahl,  time*7*(8*d/7)/anzahl);

    fill(inv2, inv2, getColor1(globalTime));
    ellipse(((r-3.5*d/7) * cos(angle-PI/4)), ((r-3.5*d/7) * sin(angle-PI/4)),   time*7*(d)/anzahl,   time*7*(d)/anzahl);

    fill(getColor1(globalTime),getColor2(globalTime), inv1);
    ellipse(((r-3*d/7) * cos(angle-growY*PI/6)), ((r-3*d/7) * sin(angle-growY*PI/6)),  time*(6*d/7)*7/anzahl,  time*(6*d/7)*7/anzahl);
 
    fill(inv2,getColor2(globalTime), getColor2(globalTime));
    ellipse(((r-2.5*d/7) * cos(angle-growY*PI/8)), ((r-2.5*d/7) * sin(angle-growY*PI/8)),  time*(5*d/7)*7/anzahl,  time*(5*d/7)*7/anzahl);
  
    fill(getColor2(globalTime),inv2, getColor2(globalTime));
    ellipse(((r-2*d/7) * cos(angle-growY*PI/10)), ((r-2*d/7) * sin(angle-growY*PI/10)),  time*(4*d/7)*7/anzahl,  time*(4*d/7)*7/anzahl);

    fill(getColor2(globalTime), inv2, inv2);
    ellipse(((r-1.5*d/7) * cos(angle-growY*PI/12)), ((r-1.5*d/7) * sin(angle-growY*PI/12)),  time*(3*d/7)*7/anzahl,  time*(3*d/7)*7/anzahl);
    popStyle();
  }
  int getColor1(float globalTime) {
    //return c1[abs( (int)(  (curTime+pow(anzahl, 2)) %255) ) ];
    return c1[abs( (int)(  ( globalTime*255))%255 )];
  }
  
  int getColor2(float globalTime) {
    //return c2[abs((int)( (curTime+pow(anzahl, 2)) %255) )  ];
    return c1[abs( (int)(  ( globalTime*255)%255) )];
  }
}

